#ifndef _SLIRC_H_
/* from slirc.c */

# define IRC_TYPE_LOG 0
# define IRC_TYPE_MSG 1
# define IRC_TYPE_SAY 2
# define IRC_TYPE_CONT 3
# define IRC_TYPE_ACTION 4
# define IRC_TYPE_INFO 5

# define CTRL_B ''
# define CTRL_O ''

# ifndef _SLIRC_C_
extern int UseColours;
extern char NullString[];
extern char *strmcpy(char*,const char*,int);
extern int IrcCmp(char*,char*,int);
#  define MAXPMS 50
extern int Rpms_ct;
extern char *Rpms[];
extern char Target[];
extern char ServerName[];
extern char NickName[];
extern void Fatal(char *) __attribute__((noreturn));
extern void SLirc_Log_Error(char*);
# endif

# ifndef _LRU_C_
/* from lru.c */
extern char LRU_dirty;
extern int init_LRU(void);
extern void DrawLRU(int);
# endif

# ifndef _SLLOAD_C_
/* from slload.c */
extern char SLirc_Load_Path[];
extern int Local_SLang_load_file(char*);
# endif

# ifndef __SLIRC_H_
/* from _slang.h */
extern int _SLstack_depth(void);
# endif

/* # ifndef _WINDOZE_C_ */
/* from windoze.c */
extern int DrawAllWindows(int, int);
extern void DirtyWindow(void);
extern void Init_Windows(void);
extern void * SLirc_Multn(char *, char *, char *, unsigned int);
/* # endif  */

/*
 * COLOUR!
 * Constants
 * These describe the different types of data.
 */

#define ColDefault 0				/* The default colour. */
#define ColTopNorm 28			/* The colour of normal bits of the top bar. */
#define ColTopHi 2					/* Hilighted parts of the top bar. */
#define ColStatusSay 3			/* The colour of the status bar in Say mode. */
#define ColStatusCommand 4	/* The colour of the status bar in Command mode. */
#define ColLogTag 5				/* The colour of the "// " bit of the log lines. */
#define ColLogText 6				/* The colour of the normal text in the Log lines. */
#define ColSayNormSend 7		/* Erk. */
#define ColSayNormDec 8
#define ColSayNormText 9
#define ColSayHiSend 10
#define ColSayHiDec 11
#define ColSayHiText 12
#define ColSayMeSend 13
#define ColSayMeDec 14
#define ColSayMeText 15
#define ColMsgNormSend 16
#define ColMsgNormDec 17
#define ColMsgNormText 18
#define ColMsgMeSend 19
#define ColMsgMeDec 20
#define ColMsgMeText 21
#define ColBufferPromptSayNorm 22
#define ColBufferPromptSayOver 23
#define ColBufferPromptCommandNorm 24
#define ColBufferPromptCommandOver 25
#define ColBufferTextSay 26
#define ColBufferTextCommand 27
/* 28 used above */
#define ColBufferTextBold 29
#define ColSayTgtoSend 30	/* Erk. */

#define ColLRUnorm 31
#define ColLRUgone 32
#define ColLRUjoin 33
#define ColLRUnmod 34
#define ColLRUactn 35
#define ColLRUmesg 36

#define ColAutoResp 37
#define ColInfoText 38 /* The colour of the normal text in the Log lines. */
#define ColPopBord 39
#define ColPopItem 40
#define ColPopISel 41


#endif
