%%% Standalone html URL fetcher.
%%% Test like: ./vf Vwget.sl
%%% Then enter URL at prompt, like: host/path/file
%%%
%%% This script uses the set_action() do_actions() `scheduler'
import("utils");
import("vfile");

define get_target ()
{
	variable r,buf;
	r = vf_write(StdOut,"URL> ");
	r = vf_read(StdIn,&buf);
	return buf;
}

variable did_server = 0;
variable target,page,host,r;
variable server;
variable server_buffer = "";

define send_string(sock, st)
{
	vmessage("<%s", chomp(st));

	variable n = vf_write(sock,st);
	if (n <= 0) {
		if (n < 0)
			vmessage("Error vf_write(server,*): %s",vf_strerr(vf_errno));
		else
      message("server closed connection");
	}
}

define handle_server(srvr, trash_which)
{
	variable buf, n, i, r, err;

	n = vf_read(srvr,&buf);
	if (n == 0) {
		message("Server closed connection.");
		r = set_action(srvr,0,NULL);
		vmessage("clr_action: %d", r);
	} else if (n < 0) {
		err = vf_errno(srvr);
		vmessage("Error vf_read(server,*)=%d: %s",err, vf_strerr(err));
		r = clr_action(srvr);
		vmessage("clr_action: %d", r);
	} else {
		buf = chomp(buf);
		vmessage(">%s",buf);
		buf = buf + "\n";
		server_buffer = server_buffer + buf;
		did_server++;
	}
}

forever {
	target = get_target;
	% Strip '\n' and whitespace
	target = strtrim(target);
	if ((0 == strcmp(target, "quit")) or (0 == strlen(target))) break; 
	
	(host,page) = v_split(target,"/");
	page = "/" + page;

	variable port = getservbyname("http");
	variable server = tcp_open(host, getservbyname("http"));
	if (server == NULL) {
		vmessage("tcp_open returned error: %s",vf_errmsg);
		continue;
	}

	vmessage("Connected: %s:%d", host, port);

	r = set_rmode(server, '\n', 1024);
	!if (r)  % r == 0 is success
		vmessage("set_rmode: %d", r);

	r = set_action(server, 0, "handle_server");
	!if (r)  % r == 0 is success
		vmessage("set_action: %d", r);

	vmessage("Requesting: http://%s%s",host,page);
	send_string(server, sprintf("GET %s HTTP/1.1\r\n",page));
	send_string(server, sprintf("Host: %s\r\n\r\n",host));

	variable server_buffer = "";

	do {
		did_server = 0;
		variable q = do_actions(15); % Up to 15 secs
	} while (did_server);

	!if (strlen(server_buffer))
		message("Init script ended... No data found?");

	r = clr_action(server);
	vmessage("clr_action: %d", r);
	variable r = vf_close(server);
	if (r < 0)
		verror("vf_close returned error: %s",vf_strerr(vf_errno));
}

message("Terminating");
