%%% TCP daytime service, to illustrate VFile TCP.
%%% use like: ./vf vdaytime.sl
%%% then enter target hostname at prompt
%%% Just a minimal demo of the vfile.c VFile interface
import("utils");
import("vfile");

define get_target ()
{
	variable r,buf;
	r = vf_write(StdOut,"DayTime Host> ");
	r = vf_read(StdIn,&buf);
	return buf;
}

variable target,host;
variable server;

define handle_server()
{
	variable buf, n, i;

	n = vf_read(server,&buf);
	if (n <= 0) {
		vmessage("vf_read returned %d",n);
		if (vf_eof(server)) 
			vmessage("Server closed connection (EOF).");
		else if (vf_error(server))
			vmessage("ERROR %d: %s",vf_error(server),vf_strerr(vf_error(server)));
		else
			message("ERROR vf_read(server): ???");
	} else {
		buf = chomp(buf); % eliminate the terminating "\r\n" or "\n"
		if (strlen(buf)) message(buf);
	}
	return n;
}

variable r;

forever {
	target = get_target();
	% Strip '\n' and whitespace off the end of the file
	host = strtrim(target);
	if ((host == "quit") or (0 == strlen(host))) break; 
	
	variable server = tcp_open(host,getservbyname("daytime"));
	if (server == NULL) {
		vmessage("tcp_open failed: %s",vf_errmsg);
		continue;
  }

	variable ip,port;
	(ip,port) = get_remote_ipp(server);
	vmessage("Connected: %s:%d", inet_ntoa(ip), port);

	% set the read-characteristics of the VFile:
  % buffered, will be 'ready' when either a '\n' is recieved
	% OR when >= 512 characters are received.
	() = set_rmode(server,'\n',512); % line-oriented, threshold=512

	variable r = 0;
	variable data_found = 0;

	while (is_readable(server, 15)) % Up to 15 secs
	{
		data_found = 1;
		r = handle_server();
		if (r <= 0) break;
	}

	!if (data_found)
		message("Init script ended... No data found?");

	r = vf_close(server);
	if (r < 0)
		vmessage("fclose returned error: %s",vf_strerr(vf_errno));
}
message("Terminating");
