%%% Finger stuff, to test TCP, really.
%%% use like: ./vf vfinger.sl
%%% then enter finger-target user@host at the prompt
set_import_module_path("..");
import("utils");
import("vfile");

define get_target ()
{
	variable r,buf;
	r = vf_write(StdOut,"Finger> ");
	r = vf_read(StdIn,&buf);
	return buf;
}

variable target,user,host;
variable server;
variable server_buffer = "";

define send_string(sock, st)
{
	variable n = vf_write(sock,st);
	if (n <= 0) {
		if (n < 0)
			vmessage("Error vf_write(server,*): %s",vf_strerr(vf_errno));
		else
      message("server closed connection");
	}
}

define handle_server()
{
	variable buf, n, i;

	n = vf_read(server,&buf);
	if (n == 0) {
		message("Server closed connection.");
	} else if (n < 0) {
		vmessage("Error vf_read(*,server): %d",errno);
	} else {
		buf = chomp(buf);
		if (strlen(buf)) message(buf);
		buf = buf + "\n";
		server_buffer = server_buffer + buf;
	}
	return n;
}

forever {
	target = get_target();
	% Strip '\n' and whitespace off the end of the file
	target = strtrim(target);
	if ((target == "quit") or (0 == strlen(target))) break; 
	
	(user,host) = v_split(target,"@");

	variable server = tcp_open(host, getservbyname("finger"));
	if (server == NULL) {
		vmessage("tcp_open returned error: %s",vf_errmsg);
		continue;
	}

	vmessage("Connected: %s", host);

	send_string(server, user + "\r\n");
	vmessage("[%s@%s]",user,host);

	variable r = 0;
	variable data_found = 0;

	while (is_readable(server, 15)) % Up to 15 secs
	{
		data_found = 1;
		r = handle_server();
		if (r <= 0) break;
	}

	!if (data_found)
		message("Init script ended... No data found?");

	r = vf_close(server);
	if (r < 0)
		verror("fclose returned error: %s",vf_strerr(vf_errno));
}

message("Terminating");
