%%% Pipe something thru babelfish to translate en->fr or fr->en.
import("utils");
import("vfile");

() = evalfile("LList.sl");

variable rlist = make_list();

variable dumpit = 0;  % set this nonzero to get a bunch of debug output

variable xl_pair,xl_tag;

% Uncomment appropriate one of these 2 lines for direction of translation
%xl_pair = "fr_en"; xl_tag = "In English:"; % French -> English
xl_pair = "en_fr"; xl_tag = "En Franais:"; % English -> French

define send_string(sock, st)
{
	variable n = vf_write(sock,st);
	if (n <= 0) {
		if (n < 0)
			vmessage("Error vf_write(%s,*): %s",string(sock),vf_strerr(vf_errno));
		else
      vmessage("server (%s) closed connection",string(sock));
	}
}

define handle_server(sock)
{
	variable buf, n;

	n = vf_read(sock,&buf);
	if (n == 0) {
		if (dumpit) message("IRC Server closed connection.");
	} else if (n < 0) {
		if (dumpit) message("Error reading from IRC Server.");
	} else {
		buf = chomp(buf);
		if (dumpit) () = vf_write(StdOut, buf + "\n");
		() = s_putlast(rlist,buf);
	}
	return n;
}

variable host = "babelfish.altavista.digital.com";

%variable hostip = gethostbyname(host);
% or, the following, which saves a nameserver lookup:
variable hostip = inet_addr("204.123.9.67");
vmessage("ip=%s",inet_ntoa(hostip));

% Input the text to be translated from stdin:
variable q,rq;
"";
while (vf_read(StdIn,&q) > 0) strcat(q);
q = ();

rq = sprintf("doit=done&urltext=%s&languagepair=%s",url_encode(q),xl_pair);

% Generate the request-header:

variable header =
	"POST /cgi-bin/translate? HTTP/1.0\r\n"
+ sprintf("Host: %s\r\n",host)
+ "Accept: text/html, text/plain, application/html, */*;q=0.001\r\n"
+ "Pragma: no-cache\r\n"
+ "Cache-Control: no-cache\r\n"
+ "Content-type: application/x-www-form-urlencoded\r\n"
+ sprintf("Content-length: %d\r\n\r\n",strlen(rq));

variable server = tcp_connect(hostip, getservbyname("www"));

if (server == NULL) {
	vmessage("tcp_open returned error: %s",vf_errmsg);
	exit(-1);
}

() = set_rmode(server,'\n',1024);

if (dumpit) vmessage("Connected: %s (%s)", host, string(server));

send_string(server,header);
send_string(server,rq);

variable r;

while (is_readable(server, 60)) % Up to 60 secs
{
	r = handle_server(server);
	if (r <= 0) break; %% r<=0 indicates closed connection or error.
}
if (dumpit) message("GOT ALL");

% now the whole reply is in the list 'rlist'
% we just fish through it to extract the part which
% is the actual translation.

if (rlist.ct) {
	variable p0,p1,ph,p,s;
	p0 = rlist.f;
	ph = s_find_n1(p0,&streq,"");
	if (ph != NULL) {
		if (dumpit) vmessage("Found end of header at %d",s_ord(ph));
		ph = ph.n;
		p = s_find_n1(ph,&is_substr,xl_tag);
		if (p != NULL) {
			if (dumpit) vmessage("Found %s at %d",xl_tag,s_ord(p));
			p1 = s_find_n1(p,&streq,"");
			if (p1 != NULL) {
				if (dumpit) vmessage("Found nlnl at %d",s_ord(p1));
				if (dumpit) message("TRbody: Start");
				for (p = p1.n; p != p0; p = p.n) {
					if (is_substr(p.v,"</td")) break;
					message(strtrim(p.v));
				}
				if (dumpit) message("TRbody: End");
			}else{message("<nl><nl> following tag not found");}
		}else{message("Tag \"%s\" not found",xl_tag);}
	}else{message("No end of header");}
}
if (dumpit) message("Terminating");
