%%% TCP to illustrate VFile TCP resolver subprocess.
%%% use like: ./vf vresolver.sl
%%% then enter target hostname at prompt
%%% demo of the vfile-module VFile interface
import("utils");
import("vfile");

define get_target ()
{
	variable r,buf;
	r = vf_write(StdOut,"Check Host> ");
	r = vf_read(StdIn,&buf);
	return buf;
}

variable target,host;

variable i,j,l,r;
variable ip,ahost,req;
variable DottedQuad,ip_rbl;
variable SpammerIP = inet_addr("127.0.0.2");

variable resolver = open_resolver();
if (resolver == NULL) {
	vmessage("Can't open resolver: %s", vf_strerr(vf_errno));
	exit(-1);
}
forever {
	target = get_target();
	% Strip '\n' and whitespace off the end of the file
	host = strtrim(target);
	if ((host == "quit") or (0 == strlen(host))) break; 

	ip = inet_addr(host);
	if (ip != -1) { % do reverse lookup on dotted quad

		req = Char_Type[1024];
		array_put_u32(req,0,ip);
		l = 8; % 8 indicates hostname lookup

	}else{

		ahost = "xxxxyyyy" + host;
		l = strlen(ahost);
		req = Char_Type[l];
		init_char_array(req,ahost);

	}

	r = vf_write(resolver,req,l);
	if (r != l) {
		vmessage("Write (%d/%d): %s",r,l,vf_strerr(vf_errno));
		continue;
	}

	r = is_readable(resolver,60);
	!if (r) {
		message("No response");
		break;
	}
	r = vf_read(resolver,req);
%	if (r != l) {
		vmessage("Read (%d/%d): %s",r,l,vf_strerr(vf_errno));
		i = array_get_u32(req,0);
		DottedQuad = inet_ntoa(i);
		j = array_get_u32(req,4);
		ahost = array_get_string(req,8);
		vmessage("IP=%s (%d) (%s)",DottedQuad,j,ahost);

		ahost = "xxxxyyyy"
		      + create_delimited_string(".",strchopr(DottedQuad,'.',0))
		      + ".rbl.maps.vix.com";

		l = strlen(ahost);
		req = Char_Type[l];
		init_char_array(req,ahost);
	r = vf_write(resolver,req,l);
	if (r != l) {
		vmessage("Write (%d/%d): %s",r,l,vf_strerr(vf_errno));
		continue;
	}
	() = is_readable(resolver,60);
	r = vf_read(resolver,req);
		vmessage("Read (%d/%d): %s",r,l,vf_strerr(vf_errno));
		i = array_get_u32(req,0);
		DottedQuad = inet_ntoa(i);
		j = array_get_u32(req,4);
		ahost = array_get_string(req,8);
		vmessage("IP=%s (%d) (%s)",DottedQuad,j,ahost);


		continue;
%	}

}
r = vf_close(resolver);
vmessage("Terminating:%d",r);
