%%% vtest.sl, script for testing VFile's tcp_open, tcp_listen, tcp_accept
%%% execute like: ./vf vtest.sl
import("utils");
import("vfile");

variable listen, accept, connect;

variable port, remote;

message("Create a listening TCP socket...");

listen = tcp_listen();

if(listen == NULL)
{
  vmessage("Argh: %s",vf_errmsg);
	exit(-2);
}
port = ();
vmessage("Okay, listen (%s) port is %d\n", string(listen),port);

message("Connect to the listening socket...");

connect = tcp_open("localhost",port);

if(connect == NULL)
{
	vmessage("Connection failed: %s", vf_errmsg);
  exit(-2);
}
vmessage("Okay, connected to localhost:%d\n", port);
% vmessage("connect=%d",vf_fileno(connect));

%variable remote;
%vmessage("fileno(listening socket)=%d",vf_fileno(listen));

message("Wait for the incoming connection...");
variable buf,f,r;
while (0 == is_readable(listen,5)) {
	message("No incoming connex");
}
message("Okay, there's an incoming\n");

message("Accept the incoming connection...");
accept = tcp_accept(listen);

if(accept == NULL)
{
	vmessage("Couldn't accept: %s", vf_errmsg);
	exit(-3);
}
(port,remote) = ();
vmessage("Okay, got (my own) connection, from %s:%d\n", remote, port);

message("Okay. Booga.");
exit(0);



% totally unbuff'd
%r = set_rmode(accept,'\n',50);
%vmessage("unbuffd=%d",r);
f = accept;
r = vf_read(f,&buf);
vmessage("read=%d",r);
if (r <= 0) {
	if (vf_eof(f))
		message("EOF");
	r = vf_error(f);
	vmessage("%d:%s",r,vf_strerr(r));
	vf_clearerr(f);
}

% is ready whenever a <nl> appears or 50 bytes
r = set_rmode(accept,-1,50);
vmessage("accept=%d,%d",vf_fileno(accept),r);

%vmessage("StdIn=%d,%d",fileno(StdIn),r);

%r = vf_close(listen);
%vmessage("vf_close(listen) = %d",r);

forever{
	do {
		f = wait_next_readable(5);
		message("*");
	}while (f == NULL);
	
	vmessage("fd=%d has data",vf_fileno(f));
	r = vf_read(f,&buf,20); % hmm
	vmessage("r=%d",r);
	if (r <= 0) exit(-1);
	message(buf);
	r = vf_write(f,sprintf(">%s",buf));
	vmessage("wrote %d bytes",r);
}
